Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_adj.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_adj.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_adj.c	(revision 2696)
@@ -0,0 +1,148 @@
+/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+   Driver for the Adjoint (ADJ) model
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
+
+int  InitSaveData();
+void Initialize();
+int  SaveData();
+int  CloseSaveData();
+int  GenerateMatlab( char * prefix );
+void GetMass( KPP_REAL CL[], KPP_REAL Mass[] );
+void INTEGRATE_ADJ( int NADJ, KPP_REAL Y[], KPP_REAL Lambda[][NVAR], 
+		    KPP_REAL TIN, KPP_REAL TOUT, KPP_REAL ATOL_adj[][NVAR], 
+		    KPP_REAL RTOL_adj[][NVAR], int ICNTRL_U[], 
+		    KPP_REAL RCNTRL_U[], int ISTATUS_U[], 
+		    KPP_REAL RSTATUS_U[] );
+
+int main() {
+
+  KPP_REAL T, DVAL[NSPEC];
+  int i, j, ind_1 = ind_O1D, ind_2 = ind_O3;
+
+  /*~~>  NADJ = Number of functionals for which sensitivities are computed
+     Note: the setting below is for sensitivities of all final concentrations;
+     the setting may have to be changed for other applications */
+  int NADJ = NVAR;
+  KPP_REAL Y_adj[NADJ][NVAR], ATOL_adj[NADJ][NVAR], RTOL_adj[NADJ][NVAR];
+
+/*~~>  Control (in) and status (out) arguments for the integration */
+  KPP_REAL RCNTRL[20], RSTATUS[20];
+  int ICNTRL[20], ISTATUS[20];
+  
+  STEPMIN = (double)0.0;
+  STEPMAX = (double)0.0;
+
+/*~~~> Tolerances for calculating concentrations */       
+  for( i=0; i<NVAR; i++) {
+    RTOL[i] = 1.0e-4;
+    ATOL[i] = 1.0e-3;
+  }
+      
+/*~~~> Tolerances for calculating adjoints 
+       are used for controlling adjoint truncation error
+       and for solving the linear adjoint equations by iterations  
+       Note: Adjoints typically span many orders of magnitude
+       and a careful tuning of ATOL_adj may be necessary */    
+  for(i=0; i<NADJ; i++) {
+    for(j=0; j<NVAR; j++) {
+      RTOL_adj[i][j] = 1.0e-4;
+      ATOL_adj[i][j] = 1.0e-10;
+    }
+  }
+     
+  Initialize();
+      
+/*~~~>  The adjoint values at the final time */
+  for(i=0; i<NADJ; i++) {
+    for(j=0; j<NVAR; j++)
+      Y_adj[i][j] = (double)0.0;
+  }
+  for(j=0; j<NADJ; j++)
+    Y_adj[j][j] = (double)1.0;
+
+/*~~~> Default control options */
+  for(i=0; i<20; i++) {
+    ICNTRL[i] = 0;
+    RCNTRL[i] = (double)0.0;
+    ISTATUS[i] = 0;
+    RSTATUS[i] = (double)0.0;
+  }     
+
+/*~~~> Begin time loop */
+
+  TIME = TSTART;
+  InitSaveData();
+
+  T = TSTART;
+
+  GetMass( C, DVAL );
+  printf("\n%6.1f%% %7.2f   ", (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600 );
+  for( i = 0; i < NMONITOR; i++ ) 
+    printf( "%9.3e  ", C[ MONITOR[i] ]/CFACTOR );
+  for( i = 0; i < NMASS; i++ ) 
+    printf( "%9.3e  ", DVAL[i]/CFACTOR );
+
+  TIME = T;
+  SaveData();
+
+  INTEGRATE_ADJ( NADJ, VAR, Y_adj, T, TEND, ATOL_adj, RTOL_adj, ICNTRL, 
+		 RCNTRL, ISTATUS, RSTATUS );
+
+  GetMass( C, DVAL );
+
+  printf("\n%6.1f%% %7.2f   ", (TEND-TSTART)/(TEND-TSTART)*100, TIME/3600 );
+  for( i = 0; i < NMONITOR; i++ ) 
+    printf( "%9.3e  ", C[ MONITOR[i] ]/CFACTOR );
+  for( i = 0; i < NMASS; i++ ) 
+    printf( "%9.3e   ", DVAL[i]/CFACTOR );
+
+  TIME = T;
+  SaveData();
+
+/*~~~> End time loop ~~~~~~~~~~*/
+
+  printf( "\n\n****************************************************\n" );
+  printf( " Concentrations and Sensitivities at final time\n" );
+  printf( " were written in the file KPP_ROOT_ADJ_results.m\n");
+  printf( "****************************************************\n");
+
+  FILE *out;
+  out = fopen("KPP_ROOT_ADJ_results.m", "w");
+  if(out == NULL) {
+    printf("Unable to open file KPP_ROOT_ADJ_results.m\n");
+    exit(1);
+  }
+
+  for(j=0; j<NADJ; j++) {
+    for(i=0; i<NVAR; i++)
+      fprintf( out, "%7.6e   ", Y_adj[j][i] );
+    fprintf( out, "\n" );
+  }
+
+  fclose(out);
+
+  printf( "\nADJ: d[%s](tf)/d[%s](t0) = %7.6e\n", SPC_NAMES[ind_1], 
+	  SPC_NAMES[ind_1], Y_adj[ind_1][ind_1] );
+  printf( "ADJ: d[%s](tf)/d[%s](t0) = %7.6e\n", SPC_NAMES[ind_2], 
+	  SPC_NAMES[ind_2], Y_adj[ind_2][ind_2] );
+  printf( "ADJ: d[%s](tf)/d[%s](t0) = %7.6e\n", SPC_NAMES[ind_2], 
+	  SPC_NAMES[ind_1], Y_adj[ind_2][ind_1] );
+  printf( "ADJ: d[%s](tf)/d[%s](t0) =  %7.6e\n\n", SPC_NAMES[ind_1], 
+	  SPC_NAMES[ind_2], Y_adj[ind_1][ind_2] );
+
+  CloseSaveData();
+ 
+/*~~~> The entire matrix of sensitivities */
+  printf("   ");
+  for(i=0; i<NVAR; i++)
+    printf( "%15s", SPC_NAMES[i] );
+  printf("\n");
+  for(j=0; j<NVAR; j++) {
+    printf("%5s = ", SPC_NAMES[j]);
+    for(i=0; i<NADJ; i++)
+      printf( " %7.6e   ",  Y_adj[i][j] );
+    printf("\n");
+  }
+
+  return 0;
+}
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_adj.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_adj.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_adj.f90	(revision 2696)
@@ -0,0 +1,122 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!   Driver for the Adjoint (ADJ) model
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+PROGRAM KPP_ROOT_ADJ_Driver
+
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+
+      KPP_REAL :: T, DVAL(NSPEC)
+      INTEGER :: i, j, ind_1 = 1, ind_2 = 2
+      ! INTEGER :: ind_1 = ind_NO2, ind_2 = ind_O3
+
+!~~>  NADJ = Number of functionals for which sensitivities are computed
+!     Note: the setting below is for sensitivities of all final concentrations;
+!           the setting may have to be changed for other applications
+      INTEGER, PARAMETER :: NADJ = NVAR
+      KPP_REAL, DIMENSION(NVAR,NADJ) :: Y_adj, ATOL_adj, RTOL_adj
+
+!~~>  Control (in) and status (out) arguments for the integration
+      KPP_REAL, DIMENSION(20) :: RCNTRL, RSTATUS
+      INTEGER,       DIMENSION(20) :: ICNTRL, ISTATUS
+  
+      STEPMIN = 0.0d0
+      STEPMAX = 0.0d0
+
+!~~~> Tolerances for calculating concentrations       
+      DO i=1,NVAR
+        RTOL(i) = 1.0d-4
+        ATOL(i) = 1.0d-3
+      END DO
+      
+!~~~> Tolerances for calculating adjoints 
+!     are used for controlling adjoint truncation error
+!     and for solving the linear adjoint equations by iterations  
+!     Note: Adjoints typically span many orders of magnitude
+!           and a careful tuning of ATOL_adj may be necessary     
+      DO j=1,NADJ
+        DO i=1,NVAR
+          RTOL_adj(i,j) = 1.0d-4
+          ATOL_adj(i,j) = 1.0d-10
+        END DO
+      END DO
+     
+      CALL Initialize()
+      
+!~~~>  The adjoint values at the final time
+      Y_adj(1:NVAR,1:NADJ) = 0.0d0
+      DO j=1,NADJ
+        Y_adj(j,j) = 1.0d0
+      END DO
+
+!~~~> Default control options
+      ICNTRL(1:20) = 0
+      RCNTRL(1:20) = 0.0d0       
+
+!~~~> Begin time loop
+
+      TIME = TSTART
+      CALL InitSaveData()
+
+      T = TSTART
+
+      CALL GetMass( C, DVAL )
+      WRITE(6,991) (T-TSTART)/(TEND-TSTART)*100, T,        &
+                  (TRIM(SPC_NAMES(MONITOR(i))),            &
+                    C(MONITOR(i))/CFACTOR, i=1,NMONITOR),  &
+                  (TRIM(SMASS(i)),DVAL(i)/CFACTOR, i=1,NMASS)
+
+      TIME = T
+      CALL SaveData()
+
+      CALL INTEGRATE_ADJ( NADJ, VAR, Y_adj, T, TEND,       &
+                          ATOL_adj, RTOL_adj,              &
+                          ICNTRL, RCNTRL, ISTATUS, RSTATUS )
+
+
+      CALL GetMass( C, DVAL )
+      WRITE(6,991) (TEND-TSTART)/(TEND-TSTART)*100, TEND,  &
+                  (TRIM(SPC_NAMES(MONITOR(i))),            &
+                    C(MONITOR(i))/CFACTOR, i=1,NMONITOR),  &
+                  (TRIM(SMASS(i)),DVAL(i)/CFACTOR, i=1,NMASS)
+
+      TIME = T
+      CALL SaveData()
+
+!~~~> End time loop ~~~~~~~~~~
+
+      OPEN(20, FILE='KPP_ROOT_ADJ_results.m')
+      WRITE(6,*) '**************************************************'
+      WRITE(6,*) ' Concentrations and Sensitivities at final time '
+      WRITE(6,*) ' were written in the file KPP_ROOT_ADJ_results.m'
+      WRITE(6,*) '**************************************************'
+      DO j=1,NADJ
+        WRITE(20,993) ( Y_adj(i,j), i=1,NVAR )          
+      END DO
+
+      WRITE(6,995) TRIM(SPC_NAMES(ind_1)),TRIM(SPC_NAMES(ind_1)), &
+                   Y_adj(ind_1,1)
+      WRITE(6,995) TRIM(SPC_NAMES(ind_2)),TRIM(SPC_NAMES(ind_2)), &
+                   Y_adj(ind_2,2)
+      WRITE(6,995) TRIM(SPC_NAMES(ind_2)),TRIM(SPC_NAMES(ind_1)), &
+                   Y_adj(ind_1,2)
+      WRITE(6,995) TRIM(SPC_NAMES(ind_1)),TRIM(SPC_NAMES(ind_2)), &
+                   Y_adj(ind_2,1)
+
+      CALL CloseSaveData()
+      
+ 991  FORMAT(F6.1,'%. T=',E10.3,3X,20(A,'=',E10.4,';',1X))
+ 993  FORMAT(1000(E24.16,2X))
+ 995  FORMAT('ADJ: d[',A,'](tf)/d[',A,'](t0)=',E14.7)
+ 
+      !~~~> The entire matrix of sensitivities
+      WRITE(6,996) ( 'd ',TRIM(SPC_NAMES(i)), i=1,NVAR ) 
+      DO j=1,NADJ
+        WRITE(6,997) TRIM(SPC_NAMES(j)),( Y_adj(j,i), i=1,NVAR )          
+      END DO
+ 996  FORMAT(12X,100('  ',A2,A6,4X))
+ 997  FORMAT('d/d',A6,' = ',100(E12.5,2X))
+
+END PROGRAM KPP_ROOT_ADJ_Driver
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_complete.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_complete.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_complete.f90	(revision 2696)
@@ -0,0 +1,114 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!   Driver for the tangent linear model
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+PROGRAM KPP_ROOT_ADJ_Driver
+
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+
+      KPP_REAL :: T, DVAL(NSPEC)
+      INTEGER :: i, j, ind_1 = ind_NO2, ind_2 = ind_O3
+
+! ---  Number of functional for which sensitivities are computed
+! ---  Note: this value is set for sensitivities w.r.t. all initial values
+! ---       it may have to be changed for other applications
+      INTEGER NADJ
+      PARAMETER (NADJ = 2)
+      KPP_REAL  Y_ADJ(NVAR,NADJ)
+      REAL(kind=dble_p)  R1(NVAR), R2(NVAR), V1, V2
+  
+! ---- TIME VARIABLES ------------------      
+
+      STEPMIN = 0.0d0
+      STEPMAX = 0.0d0
+
+      CALL SRAND(89)
+      RTOLS = 1.0d-3
+      DO i=1,NVAR
+        RTOL(i) = RTOLS
+        ATOL(i) = 1.0d-2
+        R1(i) = 10*(RAND()-0.5d0)
+        R2(i) = 10*(RAND()-0.5d0)
+      END DO
+     
+      CALL Initialize()
+! ---  Note: the initial values below are adjoint values at the final time
+     Y_ADJ(1:NVAR,1) = R1(1:NVAR)
+     Y_ADJ(1:NVAR,2) = R2(1:NVAR)
+
+! ********** T LOOP *************************
+
+      CALL InitSaveData()
+
+      WRITE(6,990) (SPC_NAMES(MONITOR(i)), i=1,NMONITOR)
+990   FORMAT('DOne[%] Time[h] ',20(4X,A12))
+
+      T = TSTART
+
+        CALL GetMass( C, DVAL )
+        WRITE(6,991) (T-TSTART)/(TEND-TSTART)*100, T/3600.,   &
+                    (C(MONITOR(i))/CFACTOR, i=1,NMONITOR),  &
+                   (DVAL(i)/CFACTOR, i=1,NMASS)
+991     FORMAT(F6.1,'% ',F7.2,3X,20(E10.4,2X))
+
+        CALL SaveData()
+
+        CALL Update_SUN() 
+        CALL Update_RCONST()
+
+        CALL INTEGRATE_ADJ( NADJ, Y_ADJ, T, TEND )
+
+      V1 = 0.0d0
+      V2 = 0.0d0
+      DO i=1,NVAR
+        V1 = V1 + Y_ADJ(i,1)*R2(i)
+        V2 = V2 + Y_ADJ(i,2)*R1(i)
+      END DO
+
+      PRINT*,'**************************************************'
+      WRITE(6,887) V1
+      WRITE(6,888) V2
+      WRITE(6,889) ABS(V1-V2)/MAX(ABS(V1),ABS(V2))
+887   FORMAT('u.M''*M''.v = ',E24.14 )
+888   FORMAT('v.M''*M''.u = ',E24.14 )
+889   FORMAT('RelativeErr=',E10.3 )
+      PRINT*,'**************************************************'
+
+      CALL GetMass( C, DVAL )
+      WRITE(6,991) (T-TSTART)/(TEND-TSTART)*100, T/3600.,    &
+                    (C(MONITOR(i))/CFACTOR, i=1,NMONITOR), &
+                    (DVAL(i)/CFACTOR, i=1,NMASS)
+
+      CALL SaveData()
+
+! *********** END TIME LOOP ********
+      OPEN(20, FILE='KPP_ROOT_ADJ_results.m')
+      WRITE(6,*) '**************************************************'
+      WRITE(6,*) ' Concentrations and Sensitivities at final time '
+      WRITE(6,*) ' were written in the file KPP_ROOT_ADJ_results.m'
+      WRITE(6,*) '**************************************************'
+      DO j=1,NADJ
+        WRITE(20,993) ( Y_ADJ(i,j), i=1,NVAR )          
+      END DO
+ 993  FORMAT(1000(E24.16,2X))
+
+      PRINT*,'ADJ: d[',TRIM(SPC_NAMES(ind_1)),'](tf) / d[', &
+            TRIM(SPC_NAMES(ind_1)),'](t0)=', Y_ADJ(ind_1,1)
+      PRINT*,'ADJ: d[',TRIM(SPC_NAMES(ind_2)),'](tf) / d[', &
+            TRIM(SPC_NAMES(ind_2)),'](t0)=', Y_ADJ(ind_2,2)
+      PRINT*,'ADJ: d[',TRIM(SPC_NAMES(ind_1)),'](tf) / d[', &
+            TRIM(SPC_NAMES(ind_2)),'](t0)=', Y_ADJ(ind_1,2)
+      PRINT*,'ADJ: d[',TRIM(SPC_NAMES(ind_2)),'](tf) / d[', &
+            TRIM(SPC_NAMES(ind_1)),'](t0)=', Y_ADJ(ind_2,1)
+
+      PRINT*,'TLM: d[NO2](tf) / d[NO2](t0)=  1.714961808143527E-002'
+      PRINT*,'TLM: d[ O3](tf) / d[ O3](t0)= -4.447774183920545E-003'
+      PRINT*,'TLM: d[NO2](tf) / d[ O3](t0)=  0.897512294491540'
+      PRINT*,'TLM: d[ O3](tf) / d[NO2](t0)= -5.543729901774693E-005'
+ 
+
+      CALL CloseSaveData()
+
+END PROGRAM KPP_ROOT_ADJ_Driver
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_ddm_ic.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_ddm_ic.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_ddm_ic.f	(revision 2696)
@@ -0,0 +1,117 @@
+C --- Driver for computing sensitivity coefficients w.r.t. all initial values
+      PROGRAM driver
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Global.h'
+
+C ---  Number of sensitivity coefficients to compute
+C ---  Note: this value is set for sensitivities w.r.t. all initial values
+C ---       it may have to be changed for other applications
+      INTEGER NSENSIT
+      PARAMETER (NSENSIT = NVAR)
+      
+      KPP_REAL  DVAL(NSPEC)
+      KPP_REAL  Y(NVAR*(NSENSIT+1))
+C ---  Note: Y contains: (1:NVAR) concentrations, followed by
+C ---                   (1:NVAR) sensitivities w.r.t. first parameter, followed by
+C ---                   etc.,  followed by          
+C ---                   (1:NVAR) sensitivities w.r.t. NSENSIT's parameter
+
+      INTEGER i
+
+C --- The type of sensitivity coefficients to compute
+C --- DDMTYPE = 0 : sensitivities w.r.t. initial values
+C --- DDMTYPE = 1 : sensitivities w.r.t. parameters
+      DDMTYPE = 0
+   
+C ---- TIME VARIABLES ------------------      
+
+      TSTART = 0
+      TEND = TSTART + 600
+      DT = 60.
+      TEMP = 298
+
+      STEPMIN = 0.01
+      STEPMAX = 900
+
+      PRINT*,'Please provide: RTOL = , ATOL = '
+      READ*,RTOLS, ATOLS
+      do i=1,NVAR
+        RTOL(i) = RTOLS
+        ATOL(i) = ATOLS
+      end do
+    
+C ********** TIME LOOP *************************
+
+      CALL Initialize()
+
+C -- Initialize Concentrations and Sensitivities
+      DO i=1,NVAR
+         Y(i) = VAR(i)
+      END DO
+	
+C ---  Note: the initial values below are for sensitivities w.r.t. initial values;
+C ---       they may have to be changed for other applications
+      DO j=1,NSENSIT
+        DO i=1,NVAR
+	   Y(i+NVAR*j) = 0.0D0
+	END DO
+	Y(j+NVAR*j) = 1.0D0
+      END DO
+
+      CALL InitSaveData()
+
+      WRITE(6,990) (SPC_NAMES(MONITOR(i)), i=1,NMONITOR), 
+     *             (SMASS(i), i=1,NMASS )
+990   FORMAT('done[%] Time[h] ',20(4X,A6))
+
+      TIME = TSTART
+      DO WHILE (TIME .lt. TEND)
+
+        CALL GetMass( C, DVAL )
+        WRITE(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600.,
+     *               (C(MONITOR(i))/CFACTOR, i=1,NMONITOR),
+     *               (DVAL(i)/CFACTOR, i=1,NMASS)
+991   FORMAT(F6.1,'% ',F7.2,3X,20(E10.4,2X))
+
+        CALL SaveData()
+
+        CALL Update_SUN() 
+        CALL Update_RCONST()
+	
+        CALL INTEGRATE( NSENSIT, Y, TIME, TIME+DT )
+
+        DO i=1,NVAR
+           VAR(i) = Y(i)
+        END DO
+	
+      END DO
+
+      CALL GetMass( C, DVAL )
+      WRITE(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600.,
+     *               (C(MONITOR(i))/CFACTOR, i=1,NMONITOR),
+     *               (DVAL(i)/CFACTOR, i=1,NMASS)
+
+C      DO i=1,NSENSIT
+C        WRITE(6,992) i, ( Y(NVAR*i+j), j=1,NVAR )          
+C      END DO
+C 992  FORMAT('SEN(',I3,') = ',1000(E10.4,2X))
+
+      CALL SaveData()
+
+C *********** END TIME LOOP ********
+      OPEN(20, FILE='KPP_ROOT_results.m')
+      WRITE(6,*) '**************************************************'
+      WRITE(6,*) '* Concentrations and Sensitivities at final time *'
+      WRITE(6,*) '*  were written in the file KPP_ROOT_results.m  *'
+      WRITE(6,*) '**************************************************'
+      DO i=0,NSENSIT
+        WRITE(20,993) ( Y(NVAR*i+j), j=1,NVAR )          
+      END DO
+ 993  FORMAT(1000(E24.16,2X))
+
+      CALL CloseSaveData()
+
+      STOP
+      END
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_hsv.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_hsv.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_hsv.f90	(revision 2696)
@@ -0,0 +1,299 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!   Driver to test Hessian Singular Vectors
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+PROGRAM KPP_ROOT_Driver
+
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+
+      KPP_REAL :: T, DVAL(NSPEC), DV(NVAR)
+      KPP_REAL :: Hs(NVAR,NVAR), SOA(NVAR)
+      INTEGER :: i, j, ind_1 = 1, ind_2 = 2, ind_COST
+      LOGICAL :: LHessian
+      INTEGER, PARAMETER :: NSOA = 1
+      KPP_REAL :: Y_tlm(NVAR,NSOA)
+      KPP_REAL :: Y_adj(NVAR,1)
+      KPP_REAL :: Y_soa(NVAR,NSOA)
+ 
+      integer          lwork, n
+      parameter        (n = NVAR)
+      
+      ! Number of desired eigenvectors
+      INTEGER, PARAMETER :: NEIG = 4
+      double complex   zwork(2000), alpha(NEIG), beta(NEIG), &
+                       eivec(n,NEIG), tmp(n), residu(n)
+
+      integer          kmax, jmax, jmin, maxstep, method, m, l, maxnmv,  &
+                       order, testspace
+      double precision tol, lock, dznrm2
+      logical          wanted
+      double complex   target
+      real             elapse
+      real             etime, tarray(2)
+
+      target = (0.0,0.0)
+      tol = 1.d-9
+      kmax = NEIG           ! Number of wanted solutions
+      jmin = 10; jmax = 20  ! min/max size of search space
+      
+      maxstep = 30  ! Max number of Jacobi-Davidson iterations
+      lock = 1.d-9
+!...     order =  0: nearest to target
+!...     order = -1: smallest real part
+!...     order =  1: largest real part
+!...     order = -2: smallest complex part
+!...     order =  2: largest complex part
+      order = 1
+
+      method = 2  ! 1=gmres(m), 2=cgstab(l)
+      m = 30      ! for gmres(m):
+      l = 2       ! for cgstab(l):
+
+      maxnmv = 20 !...     maximum number of matvecs in cgstab or gmres
+      
+      testspace = 3
+!...     Testspace 1: w = "Standard Petrov" * v (Section 3.1.1)
+!...     Testspace 2: w = "Standard 'variable' Petrov" * v (Section 3.1.2)
+!...     Testspace 3: w = "Harmonic Petrov" * v (Section 3.5.1)
+
+      if ( method .eq. 1 ) then
+         lwork =  4 +  m  + 5*jmax + 3*kmax
+      else
+         lwork = 10 + 6*l + 5*jmax + 3*kmax
+      end if
+      wanted = .true.
+
+      call jdqz(alpha, beta, eivec, wanted, n, target, tol, &
+          kmax, jmax, jmin, &
+          method, m, l, maxnmv, maxstep, &
+          lock, order, testspace, zwork, lwork )
+
+      elapse = etime( tarray )
+
+      print*,'Number of converged eigenvalues = ',kmax
+      
+!...     Compute the norms of the residuals:
+      do j = 1, kmax
+         call amul  ( n, eivec(1,j), residu )
+         call zscal ( n, beta(j), residu, 1)
+         call bmul  ( n, eivec(1,j), tmp )
+         call zaxpy( n, -alpha(j), tmp, 1, residu, 1 )
+         print '("lambda(",i2,"): (",1p,e11.4,",",e11.4, &
+             " )")', j,alpha(j)/beta(j)
+         print '(a30,d13.6)', '||beta Ax - alpha Bx||:', &
+               dznrm2( n, residu, 1 )
+      end do
+      write(*,10) tarray(1), elapse
+
+   10 format(1x,'END JDQZ AFTER ',f6.2,' SEC. CPU-TIME AND ', f6.2, &
+            ' SEC. ELAPSED TIME' )
+
+      open(120,file='KPP_ROOT_vec.m')
+      do i=1,NVAR
+        write(120,120) (eivec(i,j), j=1,NEIG)
+      end do
+      close(120)	
+
+      open(120,file='KPP_ROOT_val.m')
+      do i=1,NEIG
+        write(120,120) ALPHA(i), BETA(i), ALPHA(i)/BETA(i)
+      end do
+      close(120)	
+      
+120   format(10000(E14.7,1X))
+
+END PROGRAM KPP_ROOT_Driver
+
+
+!==========================================================================
+!     Dummy preconditioner subroutine
+!==========================================================================
+      subroutine PRECON( neq, q )
+!...............................................
+!...     Subroutine to compute q = K^-1 q
+!...............................................
+      integer        neq, i
+      double complex q(neq)
+      end subroutine PRECON
+
+
+!==========================================================================
+!     matrix vector multiplication subroutine
+!
+!
+!     Compute the matrix vector multiplication y<---A*x
+!     where A = adjoint(Model)*tlm(Model)
+!
+!     Note: we multiply the real and imaginaray parts separately
+!           x = (xr,xi)
+!           y = (yr,yi)
+!           We run the code twice such that:
+!           yr <-- A*xr and yi <-- A*xi
+!
+!==========================================================================
+      subroutine AMUL (n, u, v)
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+      integer           n, j
+      Double Complex u(n), v(n)
+      Double precision xr(n), yr(n),  xi(n), yi(n), three, two 
+      parameter         (three = 3.0D+0, two = 2.0D+0)
+      INTEGER, PARAMETER :: NSOA = 1
+      KPP_REAL :: Y_tlm(NVAR,NSOA)
+      KPP_REAL :: Y_adj(NVAR,1)
+      KPP_REAL :: Y_soa(NVAR,NSOA)
+      integer, save :: indexA = 0
+      
+      indexA = indexA + 1
+      print*,'AMUL #',indexA
+
+! Real and imaginary parts of complex inputs
+      xr(1:n) = DBLE( u(1:n) )
+      xi(1:n) = DIMAG( u(1:n) )
+
+
+      DO i=1,NVAR
+        RTOL(i) = 1.0d-4
+        ATOL(i) = 1.0d-3
+      END DO
+!~~~>  The cost function is 0.5*VAR(ind_COST, tF)**2
+      ind_COST = ind_O3
+
+! First do a FWD and a TLM integration
+      CALL Initialize()
+      Y_tlm(1:NVAR,1) = xr(1:NVAR)
+      Y_adj(1:NVAR,1) = 0.0d0
+      Y_soa(1:NVAR,1) = 0.0d0
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+
+! Set Lambda(t_final) = Y_tlm(t_final) and do backward integration
+      CALL Initialize()
+      Y_adj(1:NVAR,1) = Y_tlm(1:NVAR)
+      Y_tlm(1:NVAR,1) = 0.0d0
+      Y_soa(1:NVAR,1) = 0.0d0
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+      yr(1:NVAR) = Y_adj(1:NVAR)
+
+! First do a FWD and a TLM integration
+      CALL Initialize()
+      Y_tlm(1:NVAR,1) = xi(1:NVAR)
+      Y_adj(1:NVAR,1) = 0.0d0
+      Y_soa(1:NVAR,1) = 0.0d0
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+
+! Set Lambda(t_final) = Y_tlm(t_final) and do backward integration
+      CALL Initialize()
+      Y_adj(1:NVAR,1) = Y_tlm(1:NVAR)
+      Y_tlm(1:NVAR,1) = 0.0d0
+      Y_soa(1:NVAR,1) = 0.0d0
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+      yi(1:NVAR) = Y_adj(1:NVAR)
+
+! Convert double outputs to complex
+      DO i=1,n
+        v(i) = DCMPLX( yr(i), yi(i) )
+      END DO	
+
+
+      print*,'   (END AMUL #',indexA,')'
+      
+      end  subroutine AMUL
+
+!==========================================================================
+!     matrix vector multiplication subroutine
+!
+!     Compute the matrix vector multiplication y<---B*x
+!     where B = Hessian, and y = SOA
+!
+!     Note: we multiply the real and imaginaray parts separately
+!           x = (xr,xi)
+!           y = (yr,yi)
+!           We run the code twice such that:
+!           yr <-- B*xr and yi <-- B*xi
+!==========================================================================
+
+      subroutine BMUL (n, u, v)
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+      integer           n, j
+      Double Complex u(n), v(n)
+      Double precision xr(n), yr(n), xi(n), yi(n)
+      INTEGER, PARAMETER :: NSOA = 1
+      KPP_REAL :: Y_tlm(NVAR,NSOA)
+      KPP_REAL :: Y_adj(NVAR,1)
+      KPP_REAL :: Y_soa(NVAR,NSOA)
+      KPP_REAL :: Final(NVAR), FinalTlm(NVAR)
+      integer, save :: indexB = 0
+      
+      indexB = indexB + 1
+      print*,'BMUL #',indexB
+
+! Real and imaginary parts of complex inputs
+      xr(1:n) = DBLE( u(1:n) )
+      xi(1:n) = DIMAG( u(1:n) )
+
+      DO i=1,NVAR
+        RTOL(i) = 1.0d-4
+        ATOL(i) = 1.0d-3
+      END DO
+!~~~>  The cost function is 0.5*VAR(ind_COST, tF)**2
+      ind_COST = ind_O3
+
+! Forward & TLM integration
+      CALL Initialize()
+      Y_tlm(1:NVAR,1) = xr
+      Y_adj(1:NVAR,1) = 0.0d0
+      Y_soa(1:NVAR,1) = 0.0d0
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+      Final(1:NVAR)    = VAR(1:NVAR)			    
+      FinalTlm(1:NVAR) = Y_tlm(1:NVAR)			    
+			    
+! Adjoint and SOA integration, real part
+      CALL Initialize()
+      Y_adj(1:NVAR,1) = 0.0d0; Y_adj(ind_COST,1) = Final(ind_COST)
+      Y_soa(1:NVAR,1) = 0.0d0; Y_soa(ind_COST,1) = FinalTlm(ind_COST)
+      Y_tlm(1:NVAR,1) = xr
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+			    
+      yr(1:NVAR) = Y_soa(1:NVAR,1)			    
+
+
+! Forward & TLM integration
+      CALL Initialize()
+      Y_tlm(1:NVAR,1) = xi
+      Y_adj(1:NVAR,1) = 0.0d0
+      Y_soa(1:NVAR,1) = 0.0d0
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+      Final(1:NVAR)    = VAR(1:NVAR)			    
+      FinalTlm(1:NVAR) = Y_tlm(1:NVAR)			    
+
+! Adjoint and SOA integration, imaginary part
+      CALL Initialize()
+      Y_adj(1:NVAR,1) = 0.0d0; Y_adj(ind_COST,1) = Final(ind_COST)
+      Y_soa(1:NVAR,1) = 0.0d0; Y_soa(ind_COST,1) = FinalTlm(ind_COST)
+      Y_tlm(1:NVAR,1) = xi
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+			    
+      yi(1:NVAR) = Y_soa(1:NVAR,1)			    
+
+! Convert double outputs to complex
+      DO i=1,n
+        v(i) = DCMPLX( yr(i), yi(i) )
+      END DO	
+
+
+      print*,'   (END BMUL #',indexB,')'
+      
+      end subroutine BMUL 
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_soa.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_soa.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_soa.f90	(revision 2696)
@@ -0,0 +1,116 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!   Driver for the Second Order Adjoint (SOA) model
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+PROGRAM KPP_ROOT_SOA_Driver
+
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+
+      KPP_REAL :: T, DVAL(NSPEC)
+      INTEGER :: i, j, ind_1 = 1, ind_2 = 2
+      ! INTEGER :: ind_1 = ind_NO2, ind_2 = ind_O3
+ 
+!~~~>  Number of second order adjoints
+!      i.e., number of vectors U_i s.t. SOA_i = Hess*U_i
+!      1 <= i <= NSOA
+
+      INTEGER, PARAMETER :: NSOA = 2
+
+      KPP_REAL :: Y_tlm(NVAR,NSOA)
+      KPP_REAL :: Y_adj(NVAR)
+      KPP_REAL :: Y_soa(NVAR,NSOA)
+  
+      STEPMIN = 0.0d0
+      STEPMAX = 0.0d0
+
+      DO i=1,NVAR
+        RTOL(i) = 1.0d-4
+        ATOL(i) = 1.0d-3
+      END DO
+     
+      CALL Initialize()
+!~~~>  Tangent linear variable values at the initial time
+      Y_tlm(1:NVAR,1:NSOA) = 0.0d0
+      Y_tlm(ind_1,1) = 1.0d0
+      Y_tlm(ind_2,2) = 1.0d0
+!~~~>  Adjoint values at the final time
+      Y_adj(1:NVAR) = 0.0d0
+      Y_adj(ind_1)  = 1.0d0
+!~~~>  2nd order adjoint values at the final time      
+      Y_soa(1:NVAR,1:NSOA) = 0.0d0
+      Y_soa(ind_1,1) = 1.0d0
+      Y_soa(ind_2,2) = 1.0d0
+
+!~~~~~~~~~~~ Time LOOP ~~~~~~~~~~~~~
+
+      CALL InitSaveData()
+
+      T = TSTART
+
+        CALL GetMass( C, DVAL )
+        WRITE(6,991) (T-TSTART)/(TEND-TSTART)*100, T,      &
+                    (TRIM(SPC_NAMES(MONITOR(i))),          &
+                      C(MONITOR(i))/CFACTOR, i=1,NMONITOR),&
+                    (TRIM(SMASS(i)),DVAL(i)/CFACTOR, i=1,NMASS)
+
+        CALL SaveData()
+
+        CALL Update_SUN() 
+        CALL Update_RCONST()
+
+        CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, T, TEND, &
+                            ATOL, RTOL)
+
+
+      CALL GetMass( C, DVAL )
+      WRITE(6,991) (T-TSTART)/(TEND-TSTART)*100, T,        &
+                    (TRIM(SPC_NAMES(MONITOR(i))),          &
+                      C(MONITOR(i))/CFACTOR, i=1,NMONITOR),&
+                    (TRIM(SMASS(i)),DVAL(i)/CFACTOR, i=1,NMASS)
+
+      CALL SaveData()
+
+!~~~~~~~~~~~ END Time LOOP ~~~~~~~~~~~~~
+
+      WRITE(6,*) '**************************************************'
+      WRITE(6,*) ' Results were written in the files'
+      WRITE(6,*) ' KPP_ROOT_[TLM|ADJ|SOA].m'
+      WRITE(6,*) '**************************************************'
+      
+      PRINT 995,TRIM(SPC_NAMES(ind_1)),       &
+            TRIM(SPC_NAMES(ind_1)),           &
+            Y_tlm(ind_1,1), Y_adj(ind_1)
+      PRINT 995,TRIM(SPC_NAMES(ind_1)),       &
+            TRIM(SPC_NAMES(ind_2)),           &
+            Y_tlm(ind_1,2), Y_adj(ind_2)
+
+      DO j=1,NSOA
+         PRINT 997, j,(TRIM(SPC_NAMES(i)),Y_soa(i,j),i=1,NVAR)
+      END DO
+      
+      OPEN(53,FILE='KPP_ROOT_TLM.m')
+      DO j=1, NSOA
+         WRITE(53,993) (Y_tlm(i,j),i=1,NVAR)
+      END DO
+      CLOSE(53)
+      
+      OPEN(54,FILE='KPP_ROOT_ADJ.m')
+      WRITE(54,993) (Y_adj(i),i=1,NVAR)
+      CLOSE(54)
+      
+      OPEN(55,FILE='KPP_ROOT_SOA.m')
+      DO j=1, NSOA
+         WRITE(55,993) (Y_soa(i,j),i=1,NVAR)
+      END DO
+      CLOSE(55)
+      
+ 991  FORMAT(F6.1,'%. T=',E10.3,3X,20(A,'=',E10.4,';',1X))
+ 993  FORMAT(1000(E24.16,2X))
+ 995  FORMAT('d[',A,'](tf)/d[',A,'](t0). TLM=',E14.7,'  ADJ=',E14.7)
+ 997  FORMAT('2nd ADJ (',I3,'): ',200(A,'=',E10.3,'; '))
+
+      CALL CloseSaveData()
+
+END PROGRAM KPP_ROOT_SOA_Driver
+
